# Fusion Speedrun Notes

## Rules
- time starts on entering world
- finish when producing one bucket of helium plasma in the fusion reactor
- no item duping, no xp duping (furnace setup thingy)
- no commands etc.

## Early Game

### General
- Turtle mit Grindstone Crank
- Blazes possible from desert flower thingies

### Quarry Turtles
- 1x Glass Panes
- 7x Iron
- 7x Stone
- 3x Green/Blue Sapphire

Aim for 32 turtles as soon as possible!

### Minium Stone
- Blaze Powder "Duping"

### Nether pump setup
- 4 Redstone Engines + 2 Levers
- Buildcraft Pump
- 2x Ender Tank
- 1x Geothermal Generator

### ME Setup
Minimal Setup: 
- ME Controller
- ME Drive
- ME Access Terminal
- 1k Storage Unit

Total Cost:
1x Cutting Knife:
- 1 Iron
- 2 Quartz

1x Controller
- 4 Iron
- 4 Quartz
- 1 Quartz Dust
- 1 Diamond
- 2 Redstone

1x Drive
- 4 Iron
- 2 Glass
- 2 Gold
- 4 Redstone
- 2 Quartz Dust

1x Access Terminal
- 9 Glass
- 6 Redstone
- 8 Iron
- 2 Quartz
- 1 Gold
- 4 Quartz Dust

1x 1k Storage Unit
- 9 Redstone
- 4 Quartz
- 1 Quartz Dust
- 1 Gold
- 2 Glass
- 3 Iron

Total:
- 20 Iron
- 12 Quartz
- 8 Quartz Dust
- 21 Redstone
- 4 Gold
- 1 Diamond
- 13 Glass

### Early Necessary MF Machines
- MV Consumer
- Energy Bridge
- RF Producer
- Induction Smelter -> Brass, Invar

### Tree Farm

- Silver Upgrade
- 15x15
- 2 Harvester
- Rubber Trees
- leave space above for second farm

- 4x Induction Furnaces Raw Rubber -> Rubber Bar
- ~3 Farms needed at the end

### Autospawner Mob Farm
**Wichtige Mobs**
- Ghast (for Safari Nets, find the small ghasts in the twilight forest, take magic map, icon is the cactus-looking white symbol)
- Enderman
- Witch (get by transformation powder on skeleton druid in the twilight forest)
- Magma Cube
- Wither Skeleton
- Some animal for food

- 2 Autospawners (in one chamber, one for magma slimes (for mob essence), one for whatever else)
- 11 grinders (3 on each side, one is replaced by the door)
- 11x11 including walls
- replace floor with any block endermen can't pick up
- gold, iron and stone pipes

### ME Automation

**5x5x5 Crafter**:
- 44 Containment Walls
- 54 Heat Vents
- 18 Crafting CPUs
- 9 Pattern Provider

*probably balance more towards more crafting CPUs, fewer pattern providers*

**Total**:
- 160 Quartz
- 96 Quartz Dust
- 27 Diamonds
- 235 Gold

### Blast Furnace
34x Blocks
- 8.5x Magma Cream
- 34x Nether Bricks
- 34x Soul Sand

automate using routers

total 32x Blast Furnaces, 4x2x4:
- 4 Stacks + 16 Magma Cream
- 17 Stacks Nether Bricks (at the end can make through tome of alkahest)
- 17 Stacks Soul Sand

### Power Upgrade
- +1 stack geothermal generators

### Plate-Bender setups:
- 4x Iron plates, limit 2048
- 2x Steel plates, limit 512

### Boiler
Single Boiler costs:
- 1x Aqueous Accumulator
- 9x Liquid Fueled Firebox
- 36x Low Pressure Boiler
- 4x Liquiducts
- 1x Steam Consumer
- 1x Energy Bridge
- 1x HV-Producer

Per 2 Boilers:
- 1x MFSU
- 4x Glass Fiber
- 4x more Liquiducts
- 350EU/t power

to build:
- see boiler program

to run per layer (32 boilers):
- 4 rotary macerators
- 4 bioreactors
- produce 5600EU/t

In 3x3 Chunk Fläche:
- 2 x 16 boilers per layer
- ~4 layers -> 128 boilers

**(Important) Costs for one 2x16 layer**:
288 Liquid Fueled Fireboxes (4.5 stacks) -> **1152 steel**, **1080 iron**
1152 Low Pressure Boilers (18 stacks) -> **2304 iron (plates)**
192 Liquiducts (3 stacks) -> **48 hardened glass**
32 hv producers -> ~2 stacks gold, ~10 stacks refined iron, 5 stacks redstone
32 energy bridges -> 32 diamonds, 2 stacks gold, 1 stack redstone
32 steam consumers -> 2 stacks gold, 6 stacks iron, 32 redstone
16 mfsus -> 10 stacks lapis, 4.5 stacks iron, 16 stacks redstone
64 glass fiber -> 8 diamonds, 16 electrum
32 aqueous accumulators -> 4.5 stacks iron, 32 gold, 4 stacks glass, 32 redstone

**Rough raw item checklist for crafting one layer of boilers**:
- Iron Plates: 2.5k
- Iron Ingots: 2.2k
- Refined Iron: 700
- Steel Plates: 1.2k
- Gold: 450
- Diamonds: 40
- Lapis Lazuli: 700
- Hardened Glass: 48
- Redstone: 1.5k

## Mid Game

### Frame Quarry
- 144 Support Frames (+32-64 later)
- 120 Redstone Tube Frames
- 16 Tube Frames

**Other Mats**:
48 Mining Wells
24 Deployer
80 Block Breaker
8 Item Tesseracts
8 Energy Tesseracts
64 Red Alloy Wire
2 Repeater
1 Timer
2 Frame Motors
9 Solar Panels
1 Battery Box
1 Wireless Receiver
1 Wireless Transmitter
20 Jacketed Wire
1 Ender Chest
3 Control Tracks

### Industrial Blast

- 34x Reinforced Machine Casings (54x Steel (plates), 9x Advanced Machine Blocks, 18x Advanced Circuits)
- 2x Lava inside

End setup: 3 Stacked on top of each other
- 4x Titanium
- 4x Chrome
- 1x Tungsten (need 4x kanthal heating coils, no nichrome) (only 30 total tungsten are needed, 1 IBF takes less than an hour to make those)
- 3x Aluminium (if using aluminium for the mixed metal ingots, otherwise 1 is fine)

### Drop Mob Farms

Mineshaft und/oder Nether Fortress Mystcraft World

Make 4 drop towers
- 4x Wither Skeleton
- 30+x Witches
- 4x Endermen

Height: Minimum 45 Blocks for Endermen

### Industrial Grinder

- 3x Mercury: Sheldonite and Ferrous
- 1x Water: Gold
- If bauxite too, build an entire 4x Grinder for it (with water)

### Extractors

- 1x Nitrogen
- 1x Potassium
- 1x Silicon
- 1x Chlorite (keep 256)
- 2x Hydrogen (keep 64)
- 4x Mercury (keep 256)
- Compressed Air (do in autocrafting table)

### Platinum

Keep enough for Assemblers making Data Control Circuits etc.

64x assemblers, check that the platinum is balanced!!

**NO** bandwidth upgrade in router

## End Game

### For Iridium (need 200)
- Mine 5-6 stacks of Sheldonite Ore
- 2 Grinders for Sheldonite and Ferrous with Mercury Cells
- 1 stack of centrifuges for platinum dust
- Keep ~300 platinum for circuit boards for the fusion

More details [here](./material%20calculations/iridium_calcs.md)

### For Chrome (need 526)
- 4 IBFs for chrome dust -> chrome ingots
- 4 electrolyzers on ruby dust -> chrome dust
- 3 stacks centrifuges for redstone -> ruby dust

More details [here](./material%20calculations/chrome_calcs.md)

### For Titanium (need 280)
- 16 electrolyzers on bauxite dust

More details [here](./material%20calculations/titanium_calcs.md)

### For Beryllium (need 264)
- 4 electrolyzers on ender pearl dust

### For Helium (need 45)
- 16 centrifuges on end stone dust (make with tome of alkahest)


## Items for Fusion:

33 Fusion Coils:
- 132 Energy Flow Circuits
- 33 Superconductors
- 132 Chrome Plates
- 66 Chrome Ingots
- 132 Titanium Plates
- 33 Iridium Plates
- 264 Beryllium Cells
- 1056 Dense Copper Plates
- 4224 Coal Dust
- 4224 Tin Dust

120 Advanced Machine Casings (32 (below) + 30 (above) + 24 (inner) + 34 (outer)):
- 60 Data Control Circuits
- 300 Chrome Plates
- 120 Titanium Plates

1 Fusion Control Computer (not including the fusion coil):
- 4 Data Orbs
- 10 Energy Flow Circuits

4 Fusion Energy Injectors
- 24 Superconductors
- 32 Energy Flow Circuits
- 16 Chrome Plates
- 16 Titanium Plates
- 2 Iridium Plates
- 16 Lapotron Crystals

2 Fusion Material Injectors
- 6 Energy Flow Circuits
- 8 Chrome Plates
- 8 Titanium Plates

1 Fusion Material Extractor
- 3 Energy Flow Circuits
- 4 Chrome Plates
- 4 Titanium Plates

Total of 57 Superconductors required (15 recipes of 4):
- 45 Helium cells
- 30 Tungsten Plates
- 15 Iridium Plates
- 45 Energy Flow Circuits


**Important Base Material Totals**:
- 228 Energy Flow Circuits -> 228 Lapotron Crystals, 228 Platinum, 9576 Redstone (including redstone to lapis), 2052 Copper, 4104 Rubber
- 526 Chrome
- 280 Titanium
- 50 Iridium Plates / 200 Iridium Ingots -> Maximum of 360 or ~6 Stacks of Sheldonite necessary!!
- 264 Beryllium Cells
- 1056 Dense Copper Plates
- 289 Platinum Plates (including the ones for energy flow circuits)

## Charging the Reactor:
- Assuming full throughput, the 4 Energy Injectors can accept 32768EU/t, taking about 1 minute to fully charge the required 40 million EU.
- This would require 64 boiler pairs (4 layers) with at least partially charged MFSUs, or 85 boiler pairs without any buffer dedicated to the charging.

